| OpendTect 8.0

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Friends | List of all members
DataPack Class Referenceabstract
Basic

A data packet: data+positioning and more that needs to be shared. More...

`#include <datapack.h>`

Inheritance diagram for DataPack:
[legend]

## Classes
class | FullID

## Public Types
using | ID = DataPackID
using | MgrID = DataPackMgrID
Public Types inherited from ObjectWithName
typedef OD::String | name_type

## Public Member Functions
virtual const char * | category () const
virtual void | dumpInfo (StringPairSet &) const
FullID | fullID (DataPackMgrID mgrid) const
DataPackID | id () const
virtual bool | isOK () const
virtual float | nrKBytes () const =0
DataPack * | obtain ()
void | release ()
Threads::Lock & | updateLock () const
Public Member Functions inherited from SharedObject
| SharedObject (const char *nm=nullptr)
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Static Public Member Functions
static DataPackID | cNoID ()
static DataPackID | cUdfID ()
static DataPackID | getID (const FullID &fid)
static const char * | sKeyCategory ()
Static Public Member Functions inherited from SharedObject
static Notifier< SharedObject > & | instanceCreated ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Protected Member Functions
| DataPack (const char *categry)
| DataPack (const DataPack &)
| ~DataPack ()
void | setCategory (const char *c)
void | setManager (const DataPackMgr *)
Protected Member Functions inherited from SharedObject
| ~SharedObject ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Static Protected Member Functions
static DataPackID | getNewID ()
| ensures a global data pack ID
static float | sKb2MbFac ()
| 1 / 1024

## Protected Attributes
const BufferString | category_
const DataPackID | id_
const DataPackMgr * | manager_ = nullptr
Threads::Lock | updatelock_
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Friends
class | DataPackMgr

## Detailed Description

A data packet: data+positioning and more that needs to be shared.

The 'category' is meant like: 'Prestack gather' 'Wavelet' 'Fault surface'

<>

## Member Typedef Documentation

## ◆ ID

using DataPack::ID = DataPackID

## ◆ MgrID

using DataPack::MgrID = DataPackMgrID

## Constructor & Destructor Documentation

## ◆ DataPack() [1/2]

DataPack::DataPack | ( | const char * | categry | ) |
| protected

## ◆ DataPack() [2/2]

DataPack::DataPack | ( | const DataPack & |  | ) |
| protected

## ◆ ~DataPack()

DataPack::~DataPack | ( |  | ) |
| protected

## Member Function Documentation

## ◆ category()

virtual const char * DataPack::category | ( |  | ) | const
| inline virtual

## ◆ cNoID()

static DataPackID DataPack::cNoID | ( |  | ) |
| inline static

## ◆ cUdfID()

static DataPackID DataPack::cUdfID | ( |  | ) |
| inline static

## ◆ dumpInfo()

virtual void DataPack::dumpInfo | ( | StringPairSet & |  | ) | const
| virtual

Reimplemented in FlatDataPack, VolumeDataPack, DataPointSet, and RegularSeisDataPack.

## ◆ fullID()

FullID DataPack::fullID | ( | DataPackMgrID | mgrid | ) | const
| inline

## ◆ getID()

static DataPackID DataPack::getID | ( | const FullID & | fid | ) |
| inline static

## ◆ getNewID()

static DataPackID DataPack::getNewID | ( |  | ) |
| static protected

ensures a global data pack ID

## ◆ id()

DataPackID DataPack::id | ( |  | ) | const
| inline

## ◆ isOK()

virtual bool DataPack::isOK | ( |  | ) | const
| inline virtual

Reimplemented in FlatDataPack.

## ◆ nrKBytes()

virtual float DataPack::nrKBytes | ( |  | ) | const
| pure virtual

Implemented in BufferDataPack, FlatDataPack, VolumeDataPack, DataPointSet, PreStack::GatherSetDataPack, and SeisFlatDataPack.

## ◆ obtain()

DataPack * DataPack::obtain | ( |  | ) |

## ◆ release()

void DataPack::release | ( |  | ) |

## ◆ setCategory()

void DataPack::setCategory | ( | const char * | c | ) |
| inline protected

## ◆ setManager()

void DataPack::setManager | ( | const DataPackMgr * |  | ) |
| protected

## ◆ sKb2MbFac()

static float DataPack::sKb2MbFac | ( |  | ) |
| static protected

1 / 1024

## ◆ sKeyCategory()

static const char * DataPack::sKeyCategory | ( |  | ) |
| static

## ◆ updateLock()

Threads::Lock & DataPack::updateLock | ( |  | ) | const
| inline

## Friends And Related Symbol Documentation

## ◆ DataPackMgr

friend class DataPackMgr
| friend

## Member Data Documentation

## ◆ category_

const BufferString DataPack::category_
| protected

## ◆ id_

const DataPackID DataPack::id_
| protected

## ◆ manager_

const DataPackMgr* DataPack::manager_ = nullptr
| protected

## ◆ updatelock_

Threads::Lock DataPack::updatelock_
| mutable protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025